Index: trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/SequenceForTaskDetectionRule.java
===================================================================
--- trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/SequenceForTaskDetectionRule.java	(revision 1131)
+++ trunk/autoquest-core-tasktrees/src/main/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/SequenceForTaskDetectionRule.java	(revision 1133)
@@ -131,5 +131,5 @@
             appData.getStopWatch().start("whole loop");
             detectAndReplaceIterations(appData);
-            //mergeEqualTasks(appData);
+
             appData.getStopWatch().start("task replacement");
             detectAndReplaceTasks(appData);
@@ -158,8 +158,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param appData
      */
@@ -180,8 +176,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param appData
      */
@@ -208,92 +200,5 @@
     }
 
-//    /**
-//     * <p>
-//     * TODO: comment
-//     * </p>
-//     *
-//     * @param appData
-//     */
-//    private void mergeEqualTasks(RuleApplicationData appData) {
-//        System.out.println("merging equal tasks");
-//        appData.getStopWatch().start("merging equal tasks");
-//        
-//        int replacements = 0;
-//        List<ISequence> sessions = appData.getSessions();
-//        
-//        IdentityHashMap<ITaskTreeNode, ITaskTreeNode> replacedChildren =
-//            new IdentityHashMap<ITaskTreeNode, ITaskTreeNode>();
-//        
-//        for (int sessionIdx1 = 0; sessionIdx1 < sessions.size(); sessionIdx1++) {
-//            List<ITaskTreeNode> children1 = appData.getSessions().get(sessionIdx1).getChildren();
-//            for (int childIdx1 = 0; childIdx1 < children1.size(); childIdx1++) {
-//                // this is the child of which we search equal other children to merge and to
-//                // replace with one single unique node
-//                ITaskTreeNode child1 = children1.get(childIdx1);
-//                
-//                if (replacedChildren.containsKey(child1)) {
-//                    continue;
-//                }
-//                
-//                // now search for all other children that are equal. Also record the session they
-//                // belong to as well as the index in that session
-//                List<ITaskTreeNode> equalChildren = new LinkedList<ITaskTreeNode>();
-//                List<Integer> sessionIndexes = new LinkedList<Integer>();
-//                List<Integer> childIndexes = new LinkedList<Integer>();
-//
-//                // add all information about the current child
-//                equalChildren.add(child1);
-//                sessionIndexes.add(sessionIdx1);
-//                childIndexes.add(childIdx1);
-//                
-//                for (int sessionIdx2 = sessionIdx1; sessionIdx2 < sessions.size(); sessionIdx2++) {
-//                    List<ITaskTreeNode> children2 =
-//                          appData.getSessions().get(sessionIdx2).getChildren();
-//                    
-//                    int startIndex = (sessionIdx1 == sessionIdx2) ? childIdx1 + 1 : 0;
-//                    
-//                    for (int childIdx2 = startIndex; childIdx2 < children2.size(); childIdx2++) {
-//                        ITaskTreeNode child2 = children2.get(childIdx2);
-//                        
-//                        if ((child1 != child2) && (nodeComparator.equals(child1, child2))) {
-//                            // this is an equal child --> record its occurrence
-//                            equalChildren.add(child2);
-//                            sessionIndexes.add(sessionIdx2);
-//                            childIndexes.add(childIdx2);
-//                        }
-//                    }
-//                }
-//                
-//                // now merge the found children
-//                if (equalChildren.size() > 1) {
-//                    ITaskTreeNode replacement =
-//                        mergeVariantsOfTasks(child1.toString(), equalChildren);
-//
-//                    for (int i = 0; i < sessionIndexes.size(); i++) {
-//                        taskTreeBuilder.setChild(appData.getSessions().get(sessionIndexes.get(i)),
-//                                                 childIndexes.get(i), replacement);
-//                    
-//                        replacements++;
-//                    }
-//                    
-//                    // remember the replacement to prevent comparison of merged nodes
-//                    replacedChildren.put(replacement, replacement);
-//                    
-//                    System.out.println
-//                        ("replaced " + sessionIndexes.size() + " occurrences of " + child1);
-//                }
-//            }
-//        }
-//
-//        appData.getStopWatch().stop("merging equal tasks");
-//        
-//        System.out.println("replaced " + replacements + " equal tasks with unique replacements");
-//    }
-//
-    /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
+    /**
      * @param appData
      */
@@ -314,9 +219,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
-     * @param i
      * @return
      */
@@ -359,8 +259,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param parent
      * @return
@@ -383,8 +279,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param trie
      * @param parent
@@ -399,8 +291,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param appData
      */
@@ -445,8 +333,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param tree
      */
@@ -479,8 +363,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param appData
      * @return
@@ -493,8 +373,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param appData
      * @return
@@ -525,8 +401,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param task
      * @param parent
@@ -578,8 +450,4 @@
 
     /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
      * @param trie
      * @param object
@@ -613,8 +481,4 @@
     
     /**
-     * <p>
-     * TODO comment
-     * </p>
-     * 
      * @author Patrick Harms
      */
@@ -632,9 +496,5 @@
 
         /**
-         * <p>
-         * TODO: comment
-         * </p>
          *
-         * @param maxCount
          */
         public MaxCountAndLongestTasksFinder() {
@@ -693,9 +553,5 @@
 
         /**
-         * <p>
-         * TODO: comment
-         * </p>
-         *
-         * @return
+         *  @return
          */
         public Tasks getFoundTasks() {
@@ -705,7 +561,4 @@
 
         /**
-         * <p>
-         * TODO: comment
-         * </p>
          *
          */
@@ -740,5 +593,5 @@
      * 
      */
-    private class RuleApplicationData {
+    private static class RuleApplicationData {
         
         /**
@@ -898,11 +751,7 @@
 
     /**
-     * <p>
-     * TODO comment
-     * </p>
-     * 
      * @author Patrick Harms
      */
-    private class Tasks implements Iterable<List<ITaskTreeNode>> {
+    private static class Tasks implements Iterable<List<ITaskTreeNode>> {
         
         /**
@@ -917,8 +766,4 @@
 
         /**
-         * <p>
-         * TODO: comment
-         * </p>
-         *
          * @param occurrenceCount
          * @param sequences
@@ -931,8 +776,4 @@
 
         /**
-         * <p>
-         * TODO: comment
-         * </p>
-         *
          * @return
          */
@@ -942,8 +783,4 @@
 
         /**
-         * <p>
-         * TODO: comment
-         * </p>
-         *
          * @return
          */