Index: trunk/autoquest-core-usability-evaluation/src/main/resources/defectDescriptions.xsd
===================================================================
--- trunk/autoquest-core-usability-evaluation/src/main/resources/defectDescriptions.xsd	(revision 1036)
+++ 	(revision )
@@ -1,34 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<xsd:schema
-  targetNamespace="http://quest"
-  xmlns:tns="http://quest"
-  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
-  xmlns:jxb="http://java.sun.com/xml/ns/jaxb"
-  jxb:version="2.0"
-  elementFormDefault="qualified">
-  
-  <xsd:element name="defectDescriptions" type="tns:DefectDescriptions" />
-
-  <xsd:complexType name="DefectDescriptions">
-    <xsd:sequence>
-      <xsd:element name="defectDescription" type="tns:DefectDescription" maxOccurs="unbounded" />
-    </xsd:sequence>
-  </xsd:complexType>
-
-  <xsd:complexType name="DefectDescription">
-    <xsd:choice maxOccurs="unbounded">
-      <xsd:element name="textFragment" type="tns:SimpleFragment" />
-      <xsd:element name="parameterFragment" type="tns:ParameterFragment" />
-    </xsd:choice>
-    <xsd:attribute name="defectId" type="xsd:string" use="required" />
-  </xsd:complexType>
-
-  <xsd:simpleType name="SimpleFragment">
-    <xsd:restriction base="xsd:string"/>
-  </xsd:simpleType>
-
-  <xsd:complexType name="ParameterFragment">
-    <xsd:attribute name="parameterName" use="required" type="xsd:string" />
-  </xsd:complexType>
-
-</xsd:schema>
Index: trunk/autoquest-core-usability-evaluation/src/main/resources/defectDescriptions_en.xml
===================================================================
--- trunk/autoquest-core-usability-evaluation/src/main/resources/defectDescriptions_en.xml	(revision 1036)
+++ 	(revision )
@@ -1,44 +1,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<defectDescriptions
-  xmlns="http://quest"
-  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-  xsi:schemaLocation="http://quest defectDescriptions.xsd">
-  
-  <defectDescription defectId="TEXT_FIELD_INPUT_RATIO">
-    <textFragment>
-      The ratio of interactions that enter text into text fields is relatively high in comparison
-      with the other user interactions (
-    </textFragment>
-    <parameterFragment parameterName="textInputRatio" />
-    <textFragment>
-      ). This should be reduced. As an example, entering data can also be done using check boxes
-      or combo boxes in the case predefined values must be entered.
-    </textFragment>
-  </defectDescription>
-  
-  <defectDescription defectId="TEXT_FIELD_INPUT_REPETITIONS">
-    <textFragment>
-      Several interactions that enter text into text fields repeat tokens such as words or
-      specific signs (
-    </textFragment>
-    <parameterFragment parameterName="textRepetitionRatio" />
-    <textFragment>
-      ). This is an indicator that the same data must be entered several times. This could be
-      better supported by using e.g. automatic filling of input fields, provision of combo
-      boxes or lists prefilled with data that was already entered previously. 
-    </textFragment>
-  </defectDescription>
-  
-  <defectDescription defectId="TEXT_FIELD_NO_LETTER_OR_DIGIT_RATIO">
-    <textFragment>
-      Much of the text entered into text fields contains signs other than letters or digits (
-    </textFragment>
-    <parameterFragment parameterName="noLetterOrDigitRatio" />
-    <textFragment>
-      ). This is an indicator that the entered data has to follow a specific syntax. This should
-      be supported by syntax checking, auto completion or even providing the text fields in a way
-      that does not require the entering of special signs as they are already included at the right
-      positions.
-    </textFragment>
-  </defectDescription>
-</defectDescriptions>
Index: trunk/autoquest-core-usability-evaluation/src/main/resources/defects.props
===================================================================
--- trunk/autoquest-core-usability-evaluation/src/main/resources/defects.props	(revision 1134)
+++ trunk/autoquest-core-usability-evaluation/src/main/resources/defects.props	(revision 1134)
@@ -0,0 +1,38 @@
+[NoLetterOrDigitRatioMetric]
+
+description = The ratio of interactions that enter text into text fields is \
+              relatively high in comparison with the other user interactions (%f). \
+              This should be reduced. As an example, entering data can also be \
+              done using check boxes or combo boxes in the case  predefined values \
+              must be entered.
+
+severity.high = 0.1
+severity.medium = 0.05
+severity.low = 0.02
+severity.info = 0.01
+
+[TextInputEntryRepetitionsMetric]
+
+description = Several interactions that enter text into text fields repeat tokens such \
+              as words or specific signs (%f). This is an indicator that the same data \
+              must be entered several times. This could be better supported by using e.g. \
+              automatic filling of input fields, provision of combo boxes or lists prefilled \
+              with data that was already entered previously. 
+
+severity.high = 10
+severity.medium = 4
+severity.low = 2
+severity.info = 1
+
+[TextInputRatioMetric]
+
+description = Much of the text entered into text fields contains signs other than letters or \
+              digits (%f). This is an indicator that the entered data has to follow a specific \
+              syntax. This should be supported by syntax checking, auto completion or even providing \
+              the text fields in a way that does not require the entering of special signs as they \
+              are already included at the right positions.
+
+severity.high = 0.9
+severity.medium = 0.7
+severity.low = 0.5
+severity.info = 0.3