Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityGuidlineDescriptionResolver.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityGuidlineDescriptionResolver.java	(revision 1141)
+++ 	(revision )
@@ -1,36 +1,0 @@
-//   Copyright 2012 Georg-August-Universität Göttingen, Germany
-//
-//   Licensed under the Apache License, Version 2.0 (the "License");
-//   you may not use this file except in compliance with the License.
-//   You may obtain a copy of the License at
-//
-//       http://www.apache.org/licenses/LICENSE-2.0
-//
-//   Unless required by applicable law or agreed to in writing, software
-//   distributed under the License is distributed on an "AS IS" BASIS,
-//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-//   See the License for the specific language governing permissions and
-//   limitations under the License.
-
-package de.ugoe.cs.autoquest.usability.testutil;
-
-import de.ugoe.cs.autoquest.usability.DefectDescription;
-import de.ugoe.cs.autoquest.usability.evaluation.result.UsabilityDefectDescriptionResolver;
-import de.ugoe.cs.autoquest.usability.evaluation.rule.set.UsabilityRule;
-
-/**
- * <p>
- * TODO comment
- * </p>
- * 
- * @author Alexander Deicke
- */
-public class DummyUsabilityGuidlineDescriptionResolver implements
-    UsabilityDefectDescriptionResolver
-{
-
-    public DefectDescription descriptionFor(UsabilityRule usabilityRule) {
-        return new DefectDescription();
-    }
-
-}
Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityRuleset.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityRuleset.java	(revision 1141)
+++ 	(revision )
@@ -1,80 +1,0 @@
-//   Copyright 2012 Georg-August-Universität Göttingen, Germany
-//
-//   Licensed under the Apache License, Version 2.0 (the "License");
-//   you may not use this file except in compliance with the License.
-//   You may obtain a copy of the License at
-//
-//       http://www.apache.org/licenses/LICENSE-2.0
-//
-//   Unless required by applicable law or agreed to in writing, software
-//   distributed under the License is distributed on an "AS IS" BASIS,
-//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-//   See the License for the specific language governing permissions and
-//   limitations under the License.
-
-package de.ugoe.cs.autoquest.usability.testutil;
-
-import java.util.Collections;
-import java.util.EnumSet;
-
-import com.google.common.base.Optional;
-
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTree;
-import de.ugoe.cs.autoquest.usability.evaluation.result.UsabilityDefectSeverityLevel;
-import de.ugoe.cs.autoquest.usability.evaluation.result.UsabilityDefect;
-import de.ugoe.cs.autoquest.usability.evaluation.result.UsabilityDefectFactory;
-import de.ugoe.cs.autoquest.usability.evaluation.rule.set.UsabilityRule;
-import de.ugoe.cs.autoquest.usability.evaluation.rule.set.UsabilityRuleset;
-
-/**
- * <p>
- * TODO comment
- * </p>
- * 
- * @author Alexander Deicke
- */
-public class DummyUsabilityRuleset implements UsabilityRuleset {
-
-    private enum DummyUsabilityRule implements UsabilityRule {
-
-        DUMMY_RULE_WITH_RECOMMENDATION {
-
-            @Override
-            public Optional<UsabilityDefect> evaluate(ITaskTree taskTree) {
-                return Optional
-                    .of(new UsabilityDefectFactory(new DummyUsabilityGuidlineDescriptionResolver())
-                        .createUsabilityGuidlineRecommendation(UsabilityDefectSeverityLevel.INFO,
-                                                               this, Collections
-                                                                   .<String, String> emptyMap()));
-            }
-
-            public String ruleIdentifier() {
-                return this.name();
-            }
-
-        },
-
-        DUMMY_RULE_WITHOUT_RECOMMENDATION {
-
-            @Override
-            public Optional<UsabilityDefect> evaluate(ITaskTree taskTree) {
-                return Optional.absent();
-            }
-
-            public String ruleIdentifier() {
-                return this.name();
-            }
-        };
-
-        public abstract Optional<UsabilityDefect> evaluate(ITaskTree taskTree);
-
-    }
-
-    private final EnumSet<DummyUsabilityRule> DUMMY_USABILITY_RULESET = EnumSet
-        .allOf(DummyUsabilityRule.class);
-
-    public EnumSet<? extends UsabilityRule> evaluationRules() {
-        return DUMMY_USABILITY_RULESET;
-    }
-
-}
Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/TaskTreeBuilder.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/TaskTreeBuilder.java	(revision 1141)
+++ 	(revision )
@@ -1,109 +1,0 @@
-//   Copyright 2012 Georg-August-Universität Göttingen, Germany
-//
-//   Licensed under the Apache License, Version 2.0 (the "License");
-//   you may not use this file except in compliance with the License.
-//   You may obtain a copy of the License at
-//
-//       http://www.apache.org/licenses/LICENSE-2.0
-//
-//   Unless required by applicable law or agreed to in writing, software
-//   distributed under the License is distributed on an "AS IS" BASIS,
-//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-//   See the License for the specific language governing permissions and
-//   limitations under the License.
-
-package de.ugoe.cs.autoquest.usability.testutil;
-
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTree;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskTreeNode;
-import de.ugoe.cs.autoquest.tasktrees.treeimpl.TaskTreeNode;
-import de.ugoe.cs.autoquest.tasktrees.treeimpl.TaskTreeNodeFactory;
-
-/**
- * <p>
- * TODO comment
- * </p>
- * 
- * @author Alexander Deicke
- */
-public class TaskTreeBuilder {
-
-    public static CreateRootNodeStep builder() {
-        return new CreateRootNodeStep();
-    }
-
-    public static class CreateRootNodeStep {
-
-        public AddChildrenStep root(String name) {
-            return new AddChildrenStep(new TaskTreeNode(name));
-        }
-
-    }
-
-    public static class AddChildrenStep {
-
-        private TaskTreeNode rootNode;
-
-        public AddChildrenStep(TaskTreeNode taskTreeRootNode) {
-            this.rootNode = taskTreeRootNode;
-        }
-
-        public AddChildrenStep addChild(ITaskTreeNode childNode) {
-            this.rootNode.getChildren().add(childNode);
-            return this;
-        }
-
-        public ITaskTree creatTaskTree() {
-            return new TaskTreeNodeFactory().createTaskTree(rootNode);
-        }
-
-    }
-
-    // private Employee employee;
-    //
-    // public EmployeeBuilder() {
-    // employee = new Employee();
-    // }
-    //
-    // public static EmployeeBuilder defaultValues() {
-    // return new EmployeeBuilder();
-    // }
-    //
-    // public static EmployeeBuilder clone(Employee toClone) {
-    // EmployeeBuilder builder = defaultValues();
-    // builder.setId(toClone.getId());
-    // builder.setName(toClone.getName());
-    // builder.setDepartment(toClone.getDepartment());
-    // return builder;
-    // }
-    //
-    // public static EmployeeBuilder random() {
-    // EmployeeBuilder builder = defaultValues();
-    // builder.setId(getRandomInteger(0, 1000));
-    // builder.setName(getRandomString(20));
-    // builder.setDepartment(Department.values()[getRandomInteger(0, Department.values().length -
-    // 1)]);
-    // return builder;
-    // }
-    //
-    // public EmployeeBuilder setId(int id) {
-    // employee.setId(id);
-    // return this;
-    // }
-    //
-    // public EmployeeBuilder setName(String name) {
-    // employee.setName(name);
-    // return this;
-    // }
-    //
-    // public EmployeeBuilder setDepartment(Department dept) {
-    // employee.setDepartment(dept);
-    // return this;
-    // }
-    //
-    // public Employee build() {
-    // return employee;
-    // }
-    // }
-
-}