Index: trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/manager/TaskTreeManagerTest.java
===================================================================
--- trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/manager/TaskTreeManagerTest.java	(revision 1132)
+++ trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/manager/TaskTreeManagerTest.java	(revision 1146)
@@ -29,4 +29,5 @@
 import de.ugoe.cs.autoquest.test.DummyGUIElement;
 import de.ugoe.cs.autoquest.test.DummyInteraction;
+import de.ugoe.cs.util.console.Console;
 import de.ugoe.cs.util.console.TextConsole;
 
@@ -47,4 +48,5 @@
     @Before
     public void setUp() {
+        Console.reset();
         new TextConsole(Level.FINEST);
         manager = new TaskTreeManager();
@@ -66,10 +68,8 @@
     public void testOneEventOnOneElement() {
         simulateEvent(new DummyInteraction("bla", 1), new DummyGUIElement("elem1"));
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Event bla {}" +
-             "  }" +
-             "}", manager.getTaskTree());
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Event bla {}" +
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -84,16 +84,14 @@
         simulateEvent(new DummyInteraction("blo", 1), eventTarget);
         simulateEvent(new DummyInteraction("blu", 1), eventTarget);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget);
-
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event blo {}" +
-             "    Event blu {}" +
-             "    Event bla {}" +
-             "  }" +
-             "}", manager.getTaskTree());
+        simulateEvent(new DummyInteraction("ble", 1), eventTarget);
+
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Event bla {}" +
+             "  Event bli {}" +
+             "  Event blo {}" +
+             "  Event blu {}" +
+             "  Event ble {}" +
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -111,20 +109,18 @@
         simulateEvent(new DummyInteraction("bla", 1), eventTarget1);
         simulateEvent(new DummyInteraction("bli", 1), eventTarget2);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget3);
-        simulateEvent(new DummyInteraction("bli", 1), eventTarget4);
-        simulateEvent(new DummyInteraction("blo", 1), eventTarget5);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget6);
-
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event blo {}" +
-             "    Event bla {}" +
-             "  }" +
-             "}", manager.getTaskTree());
+        simulateEvent(new DummyInteraction("blo", 1), eventTarget3);
+        simulateEvent(new DummyInteraction("blu", 1), eventTarget4);
+        simulateEvent(new DummyInteraction("ble", 1), eventTarget5);
+        simulateEvent(new DummyInteraction("blum", 1), eventTarget6);
+
+        new TaskTreeChecker(true).assertTaskInstanceList
+            ("UserSession session {" +
+             "  Event bla {}" +
+             "  Event bli {}" +
+             "  Event blo {}" +
+             "  Event blu {}" +
+             "  Event ble {}" +
+             "  Event blum {}" +
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -142,38 +138,36 @@
         simulateEvent(new DummyInteraction("bla", 1), eventTarget1);
         simulateEvent(new DummyInteraction("bli", 1), eventTarget1);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget1);
-        simulateEvent(new DummyInteraction("bli", 1), eventTarget2);
+        simulateEvent(new DummyInteraction("blup", 1), eventTarget1);
+        simulateEvent(new DummyInteraction("ble", 1), eventTarget2);
         simulateEvent(new DummyInteraction("blo", 1), eventTarget2);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget3);
-        simulateEvent(new DummyInteraction("bli", 1), eventTarget4);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget4);
-        simulateEvent(new DummyInteraction("bli", 1), eventTarget4);
-        simulateEvent(new DummyInteraction("blo", 1), eventTarget4);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget5);
-        simulateEvent(new DummyInteraction("bli", 1), eventTarget6);
-        simulateEvent(new DummyInteraction("bla", 1), eventTarget6);
-        simulateEvent(new DummyInteraction("bli", 1), eventTarget6);
-        simulateEvent(new DummyInteraction("blo", 1), eventTarget6);
-
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event blo {}" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event blo {}" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event bla {}" +
-             "    Event bli {}" +
-             "    Event blo {}" +
-             "  }" +
-             "}", manager.getTaskTree());
+        simulateEvent(new DummyInteraction("blau", 1), eventTarget3);
+        simulateEvent(new DummyInteraction("blass", 1), eventTarget4);
+        simulateEvent(new DummyInteraction("blum", 1), eventTarget4);
+        simulateEvent(new DummyInteraction("blim", 1), eventTarget4);
+        simulateEvent(new DummyInteraction("blom", 1), eventTarget4);
+        simulateEvent(new DummyInteraction("blam", 1), eventTarget5);
+        simulateEvent(new DummyInteraction("blip", 1), eventTarget6);
+        simulateEvent(new DummyInteraction("blap", 1), eventTarget6);
+        simulateEvent(new DummyInteraction("blep", 1), eventTarget6);
+        simulateEvent(new DummyInteraction("blop", 1), eventTarget6);
+
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Event bla {}" +
+             "  Event bli {}" +
+             "  Event blup {}" +
+             "  Event ble {}" +
+             "  Event blo {}" +
+             "  Event blau {}" +
+             "  Event blass {}" +
+             "  Event blum {}" +
+             "  Event blim {}" +
+             "  Event blom {}" +
+             "  Event blam {}" +
+             "  Event blip {}" +
+             "  Event blap {}" +
+             "  Event blep {}" +
+             "  Event blop {}" +
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -187,12 +181,11 @@
         simulateEvent(event1, eventTarget1);
         simulateEvent(event1, eventTarget1);
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Iteration iteration1 {" +
-             "      Event bla {}" +
-             "    }" +
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Iteration iteration1 {" +
+             "    Event bla {}" +
+             "    Event bla {}" +
              "  }" +
-             "}", manager.getTaskTree());
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -208,12 +201,19 @@
         }
 
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Iteration iteration1 {" +
-             "      Event bla {}" +
-             "    }" +
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Iteration iteration1 {" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
              "  }" +
-             "}", manager.getTaskTree());
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -229,4 +229,6 @@
         IEventType event2 = new DummyInteraction("bli", 1);
         IEventType event3 = new DummyInteraction("blup", 1);
+        IEventType event4 = new DummyInteraction("ble", 1);
+        IEventType event5 = new DummyInteraction("blo", 1);
 
         simulateEvent(event2, eventTarget1);
@@ -235,19 +237,26 @@
             simulateEvent(event1, eventTarget1);
         }
-        simulateEvent(event3, eventTarget1);
-        simulateEvent(event2, eventTarget1);
-
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Event bli {}" +
-             "    Event blup {}" +
-             "    Iteration iteration2 {" +
-             "      Event bla {}" +
-             "    }" +
-             "    Event blup {}" +
-             "    Event bli {}" +
+        simulateEvent(event4, eventTarget1);
+        simulateEvent(event5, eventTarget1);
+
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Event bli {}" +
+             "  Event blup {}" +
+             "  Iteration iteration2 {" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
+             "    Event bla {}" +
              "  }" +
-             "}", manager.getTaskTree());
+             "  Event ble {}" +
+             "  Event blo {}" +
+             "}", manager.getTaskModel().getUserSessions().get(0));
 
     }
@@ -264,5 +273,5 @@
 
         // now test with iterations of iterations
-        for (int i = 0; i < 10; i++) {
+        for (int i = 0; i < 5; i++) {
             for (int j = 0; j < 5; j++) {
                 simulateEvent(event1, eventTarget1);
@@ -276,22 +285,124 @@
         }
 
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Iteration iteration2 {" +
-             "      Sequence sequence1 {" +
-             "        Iteration iteration3 {" +
-             "          Event bla {}" +
-             "        }" +
-             "        Iteration iteration4 {" +
-             "          Event bli {}" +
-             "        }" +
-             "        Iteration iteration5 {" +
-             "          Event blup {}" +
-             "        }" +
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Iteration iteration2 {" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration3 {" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "      }" +
+             "      Iteration iteration4 {" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration3 {" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "      }" +
+             "      Iteration iteration4 {" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration3 {" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "      }" +
+             "      Iteration iteration4 {" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration3 {" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "      }" +
+             "      Iteration iteration4 {" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration3 {" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "        Event bla {}" +
+             "      }" +
+             "      Iteration iteration4 {" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "        Event bli {}" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
+             "        Event blup {}" +
              "      }" +
              "    }" +
              "  }" +
-             "}", manager.getTaskTree());
+             "}", manager.getTaskModel().getUserSessions().get(0));
 
     }
@@ -315,16 +426,19 @@
         simulateEvent(event3, eventTarget1);
         
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Iteration iteration1 {" +
-             "      Sequence sequence2 {" +
-             "        Event bla {}" +
-             "        Event bli {}" +
-             "        Event blup {}" +
-             "      }" +
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Iteration iteration1 {" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
              "    }" +
              "  }" +
-             "}", manager.getTaskTree());
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -345,16 +459,59 @@
         }
 
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Iteration iteration1 {" +
-             "      Sequence sequence2 {" +
-             "        Event bla {}" +
-             "        Event bli {}" +
-             "        Event blup {}" +
-             "      }" +
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Iteration iteration1 {" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence2 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
              "    }" +
              "  }" +
-             "}", manager.getTaskTree());
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -375,33 +532,45 @@
         
         simulateEvent(event4, eventTarget1);
-        simulateEvent(event5, eventTarget1);
-        simulateEvent(event6, eventTarget1);
-        for (int i = 0; i < 10; i++) {
+        for (int i = 0; i < 5; i++) {
             simulateEvent(event1, eventTarget1);
             simulateEvent(event2, eventTarget1);
             simulateEvent(event3, eventTarget1);
         }
+        simulateEvent(event5, eventTarget1);
         simulateEvent(event6, eventTarget1);
-        simulateEvent(event5, eventTarget1);
-        simulateEvent(event4, eventTarget1);
-
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Event ble {}" +
-             "    Event blo {}" +
-             "    Event blu {}" +
-             "    Iteration iteration2 {" +
-             "      Sequence sequence3 {" +
-             "        Event bla {}" +
-             "        Event bli {}" +
-             "        Event blup {}" +
-             "      }" +
-             "    }" +
-             "    Event blu {}" +
-             "    Event blo {}" +
-             "    Event ble {}" +
+
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Event ble {}" +
+             "  Iteration iteration2 {" +
+             "    Sequence sequence3 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence3 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence3 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence3 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
+             "    Sequence sequence3 {" +
+             "      Event bla {}" +
+             "      Event bli {}" +
+             "      Event blup {}" +
+             "    }" +
              "  }" +
-             "}", manager.getTaskTree());
+             "  Event blo {}" +
+             "  Event blu {}" +
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 
@@ -418,7 +587,10 @@
         IEventType event5 = new DummyInteraction("blau", 1);
         IEventType event6 = new DummyInteraction("blass", 1);
+        IEventType event7 = new DummyInteraction("ble", 1);
+        IEventType event8 = new DummyInteraction("blum", 1);
+        IEventType event9 = new DummyInteraction("blop", 1);
 
         // now test with iterations of iterations
-        for (int i = 0; i < 10; i++) {
+        for (int i = 0; i < 5; i++) {
             for (int j = 0; j < 5; j++) {
                 simulateEvent(event1, eventTarget1);
@@ -432,40 +604,430 @@
             }
             for (int j = 0; j < 5; j++) {
-                simulateEvent(event1, eventTarget1);
-                simulateEvent(event3, eventTarget1);
-                simulateEvent(event5, eventTarget1);
+                simulateEvent(event7, eventTarget1);
+                simulateEvent(event8, eventTarget1);
+                simulateEvent(event9, eventTarget1);
             }
         }
 
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence root {" +
-             "  Sequence session {" +
-             "    Iteration iteration3 {" +
-             "      Sequence sequence4 {" +
-             "        Iteration iteration4 {" +
-             "          Sequence sequence4 {" +
-             "            Event bla {}" +
-             "            Event bli {}" +
-             "            Event blup {}" +
-             "          }" +
-             "        }" +
-             "        Iteration iteration5 {" +
-             "          Sequence sequence5 {" +
-             "            Event blo {}" +
-             "            Event blau {}" +
-             "            Event blass {}" +
-             "          }" +
-             "        }" +
-             "        Iteration iteration6 {" +
-             "          Sequence sequence6 {" +
-             "            Event bla {}" +
-             "            Event blup {}" +
-             "            Event blau {}" +
-             "          }" +
+        new TaskTreeChecker().assertTaskInstanceList
+            ("UserSession session {" +
+             "  Iteration iteration3 {" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration4 {" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration6 {" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration4 {" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration6 {" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration4 {" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration6 {" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration4 {" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration6 {" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "      }" +
+             "    }" +
+             "    Sequence sequence1 {" +
+             "      Iteration iteration4 {" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "        Sequence sequence4 {" +
+             "          Event bla {}" +
+             "          Event bli {}" +
+             "          Event blup {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration5 {" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "        Sequence sequence5 {" +
+             "          Event blo {}" +
+             "          Event blau {}" +
+             "          Event blass {}" +
+             "        }" +
+             "      }" +
+             "      Iteration iteration6 {" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
+             "        }" +
+             "        Sequence sequence6 {" +
+             "          Event ble {}" +
+             "          Event blum {}" +
+             "          Event blop {}" +
              "        }" +
              "      }" +
              "    }" +
              "  }" +
-             "}", manager.getTaskTree());
+             "}", manager.getTaskModel().getUserSessions().get(0));
     }
 